package org.processmining.parquetxlog.algorithms;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.info.impl.XLogInfoImpl;
import org.deckfour.xes.model.XLog;
import org.processmining.alphaminer.abstractions.AlphaClassicAbstraction;
import org.processmining.alphaminer.algorithms.AlphaMiner;
import org.processmining.alphaminer.algorithms.AlphaMinerFactory;
import org.processmining.alphaminer.parameters.AlphaMinerParameters;
import org.processmining.alphaminer.parameters.AlphaVersion;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.util.Pair;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.semantics.petrinet.Marking;

public class AlphaApplication {
	public static Pair<Petrinet, Marking> getNetFromAlphaMiner(XLog log) {
		PluginContextFactory factory = new PluginContextFactory();
		PluginContext context = factory.getContext();
		XEventClassifier classifier = XLogInfoImpl.NAME_CLASSIFIER;
		AlphaMinerParameters parameters = new AlphaMinerParameters();
		
		parameters.setVersion(AlphaVersion.CLASSIC);
		
		AlphaMiner<XEventClass, ? extends AlphaClassicAbstraction<XEventClass>, ? extends AlphaMinerParameters> miner = AlphaMinerFactory
				.createAlphaMiner(context, log, classifier, parameters);

		Pair<Petrinet, Marking> markedNet = miner.run();
		
		return markedNet;
	}
}
