package org.processmining.parquetxlog.models;

import java.util.Collection;
import java.util.Date;
import java.util.Map;
import java.util.Set;

import org.apache.avro.generic.GenericRecord;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.impl.XAttributeTimestampImpl;

import gnu.trove.set.hash.THashSet;

public class ParquetXAttributeMapImpl implements XAttributeMap {
	String activity;
	GenericRecord record;
	public Set<String> keyset;
	
	public ParquetXAttributeMapImpl(GenericRecord record) {
		SingletonKeyset singletonKeyset = SingletonKeyset.getInstance(record);
		this.keyset = new THashSet<String>(singletonKeyset.keyset);
		activity = (String)record.get("conceptAAAname");
		if (!IsMinimal.IS_MINIMAL) {
			this.record = record;
		}
	}
	
	public ParquetXAttributeMapImpl(String activity, Set<String> keyset) {
		this.keyset = keyset;
		this.activity = activity;
	}
	
	public Object clone() {
		if (record == null) {
			return new ParquetXAttributeMapImpl(activity, keyset);
		}
		return new ParquetXAttributeMapImpl(record);
	}
	
	public int size() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean containsKey(Object key) {
		// TODO Auto-generated method stub
		Object value = record.get(key.toString());
		if (value != null) {
			return true;
		}
		return false;
	}

	public boolean containsValue(Object value) {
		// TODO Auto-generated method stub
		return false;
	}

	public XAttribute get(Object key) {
		// TODO Auto-generated method stub
		String keyStr = key.toString();
		if (keyStr.equals("concept:name")) {
			return new XAttributeLiteralParquetImpl(keyStr, (String)activity);
		}
		if (IsMinimal.IS_MINIMAL) {
			if (keyStr.equals("time:timestamp")) {
				return new XAttributeTimestampImpl(keyStr, new Date());
			}
			else if (keyStr.equals("org:resource")) {
				return new XAttributeLiteralParquetImpl(keyStr, "");
			}
			else if (keyStr.equals("lifecycle:transition")) {
				return new XAttributeLiteralParquetImpl(keyStr, "complete");
			}
		}
		String newKey = keyStr.replaceAll(":", "AAA");
						
		Object value = record.get(newKey);
		if (value instanceof String) {			
			return new XAttributeLiteralParquetImpl(keyStr, (String)value);
		}
		
		return null;
	}

	public XAttribute put(String key, XAttribute value) {
		// TODO Auto-generated method stub
		return null;
	}

	public XAttribute remove(Object key) {
		// TODO Auto-generated method stub
		return null;
	}

	public void putAll(Map<? extends String, ? extends XAttribute> m) {
		// TODO Auto-generated method stub
		
	}

	public void clear() {
		// TODO Auto-generated method stub
		
	}

	public Set<String> keySet() {
		// TODO Auto-generated method stub
		return this.keyset;
	}

	public Collection<XAttribute> values() {
		// TODO Auto-generated method stub
		return null;
	}

	public Set<Entry<String, XAttribute>> entrySet() {
		// TODO Auto-generated method stub
		return null;
	}

}
