package org.processmining.parquetxlog.models;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Set;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.info.XLogInfo;
import org.deckfour.xes.info.impl.XLogInfoImpl;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeMap;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.XVisitor;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.deckfour.xes.model.impl.XAttributeMapImpl;

public class ParquetXLogImpl implements XLog {
	public List<XTrace> traces;
	
	public ParquetXLogImpl() {
		traces = new ArrayList<XTrace>();
	}
	
	public Object clone() {
		ParquetXLogImpl clone = new ParquetXLogImpl();
		for (XTrace trace : traces) {
			clone.traces.add((XTrace) trace.clone());
		}
		return clone;
	}

	public XAttributeMap getAttributes() {
		// TODO Auto-generated method stub
		XAttributeMapImpl logAttributes = new XAttributeMapImpl();
		
		logAttributes.put("concept:name", new XAttributeLiteralImpl("concept:name", "Log"));
		
		return logAttributes;
	}

	public Set<XExtension> getExtensions() {
		// TODO Auto-generated method stub
		return new HashSet<XExtension>();
	}

	public boolean hasAttributes() {
		// TODO Auto-generated method stub
		return false;
	}

	public void setAttributes(XAttributeMap arg0) {
		// TODO Auto-generated method stub
		
	}

	public int size() {
		// TODO Auto-generated method stub
		return traces.size();
	}

	public boolean isEmpty() {
		// TODO Auto-generated method stub
		return traces.isEmpty();
	}

	public boolean contains(Object o) {
		// TODO Auto-generated method stub
		return traces.contains(o);
	}

	public Iterator<XTrace> iterator() {
		// TODO Auto-generated method stub
		return traces.iterator();
	}

	public Object[] toArray() {
		// TODO Auto-generated method stub
		return traces.toArray();
	}

	public <T> T[] toArray(T[] a) {
		// TODO Auto-generated method stub
		return traces.toArray(a);
	}

	public boolean add(XTrace e) {
		// TODO Auto-generated method stub
		return traces.add(e);
	}

	public boolean remove(Object o) {
		// TODO Auto-generated method stub
		return traces.remove(o);
	}

	public boolean containsAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return traces.containsAll(c);
	}

	public boolean addAll(Collection<? extends XTrace> c) {
		// TODO Auto-generated method stub
		return traces.addAll(c);
	}

	public boolean addAll(int index, Collection<? extends XTrace> c) {
		// TODO Auto-generated method stub
		return traces.addAll(index, c);
	}

	public boolean removeAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return traces.removeAll(c);
	}

	public boolean retainAll(Collection<?> c) {
		// TODO Auto-generated method stub
		return traces.retainAll(c);
	}

	public void clear() {
		// TODO Auto-generated method stub
		
	}

	public XTrace get(int index) {
		// TODO Auto-generated method stub
		return traces.get(index);
	}

	public XTrace set(int index, XTrace element) {
		// TODO Auto-generated method stub
		return traces.set(index, element);
	}

	public void add(int index, XTrace element) {
		// TODO Auto-generated method stub
		traces.add(index, element);
	}

	public XTrace remove(int index) {
		// TODO Auto-generated method stub
		return traces.remove(index);
	}

	public int indexOf(Object o) {
		// TODO Auto-generated method stub
		return traces.indexOf(o);
	}

	public int lastIndexOf(Object o) {
		// TODO Auto-generated method stub
		return traces.lastIndexOf(o);
	}

	public ListIterator<XTrace> listIterator() {
		// TODO Auto-generated method stub
		return traces.listIterator();
	}

	public ListIterator<XTrace> listIterator(int index) {
		// TODO Auto-generated method stub
		return traces.listIterator(index);
	}

	public List<XTrace> subList(int fromIndex, int toIndex) {
		// TODO Auto-generated method stub
		return traces.subList(fromIndex, toIndex);
	}

	public boolean accept(XVisitor arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	public List<XEventClassifier> getClassifiers() {
		// TODO Auto-generated method stub
		List<XEventClassifier> classifiers = new ArrayList<XEventClassifier>();
		classifiers.add(XLogInfoImpl.NAME_CLASSIFIER);
				
		return classifiers;
	}

	public List<XAttribute> getGlobalEventAttributes() {
		// TODO Auto-generated method stub
		return new ArrayList<XAttribute>();
	}

	public List<XAttribute> getGlobalTraceAttributes() {
		// TODO Auto-generated method stub
		return new ArrayList<XAttribute>();
	}

	public XLogInfo getInfo(XEventClassifier arg0) {
		// TODO Auto-generated method stub
		List<XEventClassifier> classifiers = new ArrayList<XEventClassifier>();
		classifiers.add(XLogInfoImpl.NAME_CLASSIFIER);
		
		XLogInfo xLogInfo = new ParquetXLogInfoImpl(this, arg0, classifiers);
		
		return xLogInfo;
	}

	public void setInfo(XEventClassifier arg0, XLogInfo arg1) {
		// TODO Auto-generated method stub
		
	}

}
