package org.processmining.parquetxlog.models;

import java.util.List;
import java.util.Set;

import org.apache.avro.Schema.Field;
import org.apache.avro.generic.GenericRecord;

import gnu.trove.set.hash.THashSet;

public class SingletonKeyset 
{ 
    // static variable single_instance of type Singleton 
    private static SingletonKeyset single_instance = null; 
  
    // variable of type String 
    public Set<String> keyset;
  
    // private constructor restricted to this class itself 
    private SingletonKeyset(GenericRecord record) 
    {
    	this.keyset = new THashSet<String>();
		List<Field> fields = record.getSchema().getFields();
		for (Field field : fields) {
			keyset.add(field.name().replaceAll("AAA", ":"));
		}
    } 
  
    // static method to create instance of Singleton class 
    public static SingletonKeyset getInstance(GenericRecord record) 
    { 
        if (single_instance == null) 
            single_instance = new SingletonKeyset(record); 
  
        return single_instance; 
    }
    
    public static void destroyInstance() {
    	single_instance = null;
    }
} 